//------------------------------------------------------------------
#property copyright "www.forex-TSD.com "
#property link      "www.forex-tsd.com/"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_color4  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_style4  STYLE_DOT
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1  80
#property indicator_level2  20
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern string TimeFrame    = "Current time frame";
extern int    KPeriod      = 5;
extern int    DPeriod      = 3;
extern int    Slowing      = 3;
extern int    Price        = 0; 
extern int    MaMethod     = 0; 
extern double T3Period     = 5;
extern double T3Hot        = 0.618;
extern bool   T3Original   = true;
extern bool   ColorOnSlope = true;

//
//
//
//
//

double Stochastic[];
double StochasticDa[];
double StochasticDb[];
double Stochastic_Signal[];
double state[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame = 0;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0, Stochastic);
   SetIndexBuffer(1, StochasticDa);
   SetIndexBuffer(2, StochasticDb);
   SetIndexBuffer(3, Stochastic_Signal);
   SetIndexBuffer(4, state);
   
   //
   //
   //
   //
   //
       
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   calculateValue    = TimeFrame == "calculateValue"; if (calculateValue) return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
          
   //
   //
   //
   //
   //

   IndicatorShortName(timeFrameToString(timeFrame)+ " Stochastic T3("+KPeriod+","+DPeriod+","+Slowing+", T3 "+DoubleToStr(T3Period,1)+ ")");
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Stochastic[0] = limit+1; return(0); }

         //
         //
         //
         //
         //
         
         if (calculateValue || timeFrame == Period())
         {
           if (state[limit]==-1) CleanPoint(limit,StochasticDa,StochasticDb);
           for (i=limit; i>=0 ; i--)
           {
              Stochastic[i]        = iT3(iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MaMethod,Price,MODE_MAIN  ,i),T3Period,T3Hot,T3Original,i,0);
              Stochastic_Signal[i] = iT3(iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MaMethod,Price,MODE_SIGNAL,i),T3Period,T3Hot,T3Original,i,1);
              StochasticDa[i]      = EMPTY_VALUE;
              StochasticDb[i]      = EMPTY_VALUE;
              state[i] = state[i+1];
               if (ColorOnSlope)
               {
                  if (Stochastic[i]>Stochastic[i+1]) state[i] =  1;
                  if (Stochastic[i]<Stochastic[i+1]) state[i] = -1;
               }
               else
               {
                  if (Stochastic[i]>Stochastic_Signal[i+1]) state[i] =  1;
                  if (Stochastic[i]<Stochastic_Signal[i+1]) state[i] = -1;
               }
               if (state[i]==-1) PlotPoint(i,StochasticDa,StochasticDb,Stochastic);
               
         }   
   return(0);
   }
   
   //
   //
   //
   //
   //       
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (state[limit]==-1) CleanPoint(limit,StochasticDa,StochasticDb);
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         Stochastic[i]        = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",KPeriod,DPeriod,Slowing,Price,MaMethod,T3Period,T3Hot,T3Original,0,y);
         StochasticDa[i]      = EMPTY_VALUE;
         StochasticDb[i]      = EMPTY_VALUE; 
         Stochastic_Signal[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",KPeriod,DPeriod,Slowing,Price,MaMethod,T3Period,T3Hot,T3Original,3,y);
         state[i]             = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",KPeriod,DPeriod,Slowing,Price,MaMethod,T3Period,T3Hot,T3Original,4,y);
         if (ColorOnSlope)
         {
            if (Stochastic[i]>Stochastic[i+1]) state[i] =  1;
            if (Stochastic[i]<Stochastic[i+1]) state[i] = -1;
         }
         else
         {
            if (Stochastic[i]>Stochastic_Signal[i+1]) state[i] =  1;
            if (Stochastic[i]<Stochastic_Signal[i+1]) state[i] = -1;
         }
    }
    for (i=limit;i>=0;i--) if (state[i]==-1) PlotPoint(i,StochasticDa,StochasticDb,Stochastic);
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][12];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) !=Bars)                 ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

